commit 46bd69dd319b52703fdaee37f90492ff4e987814
Author: freddy77 <freddy77>
Date:   Fri Jul 30 07:29:48 2010 +0000

    remove oserr from tds_socket

diff --git a/ChangeLog b/ChangeLog
index 3a2b4e4..8afc970 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Jul 30 09:29:34 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/login.c src/tds/net.c:
+	- remove oserr from tds_socket
+
 Fri Jul 30 09:17:15 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* configure.ac src/odbc/Makefile.am win32/FreeTDS.def:
 	- win32/FreeTDSW.def
@@ -2778,4 +2782,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3099 2010/07/30 07:17:27 freddy77 Exp $
+$Id: ChangeLog,v 1.3100 2010/07/30 07:29:48 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index c442f4a..577b732 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -21,7 +21,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.341 2010/07/27 08:53:12 freddy77 Exp $ */
+/* $Id: tds.h,v 1.342 2010/07/30 07:29:48 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1292,7 +1292,7 @@ typedef struct tds_authentication
 struct tds_socket
 {
 	TDS_SYS_SOCKET s;		/**< tcp socket, INVALID_SOCKET if not connected */
-	int oserr;
+
 	TDS_USMALLINT tds_version;
 	TDS_UINT product_version;	/**< version of product (Sybase/MS and full version) */
 	char *product_name;
@@ -1331,7 +1331,7 @@ struct tds_socket
 
 	volatile 
 	unsigned char in_cancel; 	/**< indicate we are waiting a cancel reply; discard tokens till acknowledge */
-	
+
 	TDS_INT8 rows_affected;		/**< rows updated/deleted/inserted/selected, TDS_NO_COUNT if not valid */
 	TDS_INT query_timeout;
 	TDSENV env;
@@ -1573,7 +1573,7 @@ extern int tds_g_append_mode;
 
 /* net.c */
 int tds_lastpacket(TDSSOCKET * tds);
-TDSERRNO tds_connect(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout);
+TDSERRNO tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout, int *p_oserr);
 int tds_close_socket(TDSSOCKET * tds);
 int tds_read_packet(TDSSOCKET * tds);
 int tds_write_packet(TDSSOCKET * tds, unsigned char final);
diff --git a/src/tds/login.c b/src/tds/login.c
index bf4d45d..8b94d41 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.197 2010/07/27 08:53:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.198 2010/07/30 07:29:48 freddy77 Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -313,8 +313,8 @@ free_save_context(TDSSAVECONTEXT *ctx)
  * 		- TDSEFCON: connect(2) succeeded, login packet not acknowledged.  
  *		- TDS_FAIL: connect(2) succeeded, login failed.  
  */
-int
-tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
+static int
+tds_connect(TDSSOCKET * tds, TDSCONNECTION * connection, int *p_oserr)
 {
 	int erc = TDSEFCON;
 	int connect_timeout = 0;
@@ -355,7 +355,7 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 			connection->tds_version = versions[i];
 			reset_save_context(&save_ctx);
 
-			if ((erc = tds_connect_and_login(tds, connection)) != TDS_SUCCEED) {
+			if ((erc = tds_connect(tds, connection, p_oserr)) != TDS_SUCCEED) {
 				tds_close_socket(tds);
 			}
 			
@@ -370,7 +370,7 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		free_save_context(&save_ctx);
 		
 		if (erc != TDS_SUCCEED)
-			tdserror(tds->tds_ctx, tds, erc, tds->oserr); 
+			tdserror(tds->tds_ctx, tds, erc, *p_oserr);
 
 		return erc;
 	}
@@ -403,12 +403,6 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		}
 	}
 
-	/* specified a date format? */
-	/*
-	 * if (connection->date_fmt) {
-	 * tds->date_fmt=strdup(connection->date_fmt);
-	 * }
-	 */
 	connect_timeout = connection->connect_timeout;
 
 	/* Jeff's hack - begin */
@@ -437,8 +431,10 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 
 	memcpy(tds->capabilities, connection->capabilities, TDS_MAX_CAPABILITY);
 
-	if ((erc = tds_connect(tds, tds_dstr_cstr(&connection->ip_addr), connection->port, connect_timeout)) != TDS_SUCCEED)
+	if ((erc = tds_open_socket(tds, tds_dstr_cstr(&connection->ip_addr), connection->port, connect_timeout, p_oserr)) != TDSEOK) {
+		tdserror(tds->tds_ctx, tds, erc, *p_oserr);
 		return erc;
+	}
 		
 	/*
 	 * Beyond this point, we're connected to the server.  We know we have a valid TCP/IP address+socket pair.  
@@ -495,6 +491,13 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	return TDS_SUCCEED;
 }
 
+int
+tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
+{
+	int oserr = 0;
+	return tds_connect(tds, connection, &oserr);
+}
+
 static int
 tds_put_login_string(TDSSOCKET * tds, const char *buf, int n)
 {
diff --git a/src/tds/net.c b/src/tds/net.c
index fff325c..eb11d27 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -107,7 +107,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.104 2010/07/25 08:40:19 freddy77 Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.105 2010/07/30 07:29:48 freddy77 Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL) && !defined(C_INTERIX)
@@ -124,7 +124,6 @@ TDS_RCSID(var, "$Id: net.c,v 1.104 2010/07/25 08:40:19 freddy77 Exp $");
 #endif
 
 static int      tds_select(TDSSOCKET * tds, unsigned tds_sel, int timeout_seconds);
-static TDSERRNO tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout);
 
 
 /**
@@ -189,17 +188,7 @@ typedef u_long ioctl_nonblocking_t;
 #endif
 
 TDSERRNO
-tds_connect(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout)
-{
-	TDSERRNO erc = tds_open_socket(tds, ip_addr, port, timeout);
-	if (TDSEOK != erc) {
-		tdserror(tds->tds_ctx, tds, erc, tds->oserr);  
-	}
-	return erc;
-}
-
-static TDSERRNO
-tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout)
+tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout, int *p_oserr)
 {
 	struct sockaddr_in sin;
 	ioctl_nonblocking_t ioctl_nonblocking;
@@ -209,7 +198,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 	int tds_error = TDSECONN;
 	char ip[20];
 
-	tds->oserr = 0;
+	*p_oserr = 0;
 
 	memset(&sin, 0, sizeof(sin));
 
@@ -227,7 +216,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 			TDS_MAJOR(tds), TDS_MINOR(tds));
 
 	if (TDS_IS_SOCKET_INVALID(tds->s = socket(AF_INET, SOCK_STREAM, 0))) {
-		tds->oserr = sock_errno;
+		*p_oserr = sock_errno;
 		tdsdump_log(TDS_DBG_ERROR, "socket creation error: %s\n", sock_strerror(sock_errno));
 		return TDSESOCK;
 	}
@@ -251,7 +240,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 	if (connect(tds->s, (struct sockaddr *) &sin, sizeof(sin)) < 0) {
 		char *message;
 
-		tds->oserr = sock_errno;
+		*p_oserr = sock_errno;
 		if (asprintf(&message, "tds_open_socket(): %s:%d", inet_ntoa(sin.sin_addr), ntohs(sin.sin_port)) >= 0) {
 			perror(message);
 			free(message);
@@ -268,7 +257,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 	/* enable non-blocking mode */
 	ioctl_nonblocking = 1;
 	if (IOCTLSOCKET(tds->s, FIONBIO, &ioctl_nonblocking) < 0) {
-		tds->oserr = sock_errno;
+		*p_oserr = sock_errno;
 		tds_close_socket(tds);
 		return TDSEUSCT; 	/* close enough: "Unable to set communications timer" */
 	}
@@ -277,7 +266,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 	if (retval == 0) {
 		tdsdump_log(TDS_DBG_INFO2, "connection established\n");
 	} else {
-		int err = tds->oserr = sock_errno;
+		int err = *p_oserr = sock_errno;
 		tdsdump_log(TDS_DBG_ERROR, "tds_open_socket: connect(2) returned \"%s\"\n", sock_strerror(err));
 #if DEBUGGING_CONNECTING_PROBLEM
 		if (err != ECONNREFUSED && err != ENETUNREACH && err != TDSSOCK_EINPROGRESS) {
@@ -308,12 +297,12 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 	optlen = sizeof(len);
 	len = 0;
 	if (tds_getsockopt(tds->s, SOL_SOCKET, SO_ERROR, (char *) &len, &optlen) != 0) {
-		tds->oserr = sock_errno;
+		*p_oserr = sock_errno;
 		tdsdump_log(TDS_DBG_ERROR, "getsockopt(2) failed: %s\n", sock_strerror(sock_errno));
 		goto not_available;
 	}
 	if (len != 0) {
-		tds->oserr = len;
+		*p_oserr = len;
 		tdsdump_log(TDS_DBG_ERROR, "getsockopt(2) reported: %s\n", sock_strerror(len));
 		goto not_available;
 	}

